"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
const theme_1 = __importDefault(require("../ui/common/theme"));
const title = (str) => chalk_1.default.hex(theme_1.default.mainColor).bold(str);
const name = chalk_1.default.hex(theme_1.default.secondColor)(`coder-notifier`);
const prompt = chalk_1.default.gray("$");
const label = (str) => chalk_1.default.hex(theme_1.default.secondColor)(str);
exports.default = `
${title("使用：")}
  ${prompt} ${name} ${chalk_1.default.gray('[--version|--v] [--help|--h] <command> [<args>]')}

${title("例子：")}
  ${prompt} ${name} ${chalk_1.default.hex(theme_1.default.lastColor)("set")}

${title("参数：")}
  ${label("help | h ")}     ${chalk_1.default.gray('查看帮助文档')}
  ${label("version | v")}   ${chalk_1.default.gray('查看版本号')}

${title("命令：")}
  ${label("set")}           ${chalk_1.default.gray('设置。使用该命令可以设置一些通知。')}
  ${label("start")}         ${chalk_1.default.gray('启动。该命令是一次性的，启动后关闭控制台或者关闭电脑都会停止通知。')}
  ${label("save")}          ${chalk_1.default.gray('保存启动脚本。使用该命令可以让coder-notifier持久运行，电脑重启后也会自动启动。')}
  ${label("stop")}          ${chalk_1.default.gray('停止。该命令可以退出coder-notifier持久运行。使用该命令后，coder-notifier将会永久退出不会开机启动。')}
  ${label("about")}         ${chalk_1.default.gray('关于我们。')}
`;
