"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const ink_1 = require("ink");
const Logo_1 = __importDefault(require("./components/Logo"));
const SetForm_1 = __importDefault(require("./components/SetForm"));
const Select_1 = __importDefault(require("./components/Select"));
const Tips_1 = __importDefault(require("./components/Tips"));
const settingHelper_1 = require("./common/settingHelper");
const MyTable_1 = __importDefault(require("./components/MyTable"));
const ImportSet_1 = __importDefault(require("./components/ImportSet"));
const utils_1 = require("./common/utils");
const ink_syntax_highlight_1 = __importDefault(require("ink-syntax-highlight"));
const theme_1 = __importDefault(require("./common/theme"));
// eslint-disable-next-line @typescript-eslint/no-var-requires
const ncp = require("copy-paste");
const SetView = () => {
    // 步骤
    const [setup, setSetup] = (0, react_1.useState)(0);
    // 操作类型
    const [actionType, setActionType] = (0, react_1.useState)("add");
    // 设置
    const [setting, setSetting] = (0, react_1.useState)({});
    // 更新的通知索引
    const [updateIndex, setUpdateIndex] = (0, react_1.useState)();
    // 导入配置
    const [importText, setImportText] = (0, react_1.useState)("");
    // 提示
    const [tips, setTips] = (0, react_1.useState)({
        isShow: false,
        type: "success",
        message: "",
    });
    const tipsRef = (0, react_1.useRef)();
    (0, react_1.useEffect)(() => {
        setSetting((0, settingHelper_1.readSetting)() || {});
    }, []);
    const onSelectAction = (item) => {
        setTips({ isShow: false });
        tipsRef.current.clear();
        setActionType(item.value);
        if (item.value === "add") {
            setSetup(2);
        }
        else if (["delete", "update"].includes(item.value)) {
            if ((setting.list || []).length === 0) {
                setTips({
                    isShow: true,
                    type: "info",
                    message: "您还没有通知，请先添加一个吧。",
                });
            }
            else {
                setSetup(1);
            }
        }
        else if (["import"].includes(item.value)) {
            setSetup(3);
        }
        else if (item.value === "export") {
            setSetup(3);
            ncp.copy(JSON.stringify(setting), () => {
                setTips({
                    isShow: true,
                    type: "success",
                    message: "导出成功，已经帮您复制到剪切板。",
                });
            });
        }
        else if (item.value === "query") {
            setSetup(3);
            if ((setting.list || []).length === 0) {
                setTips({
                    isShow: true,
                    type: "info",
                    message: "您还没有设置通知，请先添加一条通知吧。",
                });
            }
        }
    };
    const onSetFormConfirm = (form) => {
        if (actionType === "add") {
            tipsRef.current.clear();
            const settings = (setting === null || setting === void 0 ? void 0 : setting.list) || [];
            settings.push(form);
            setting.list = settings;
            setSetting(setting);
            (0, settingHelper_1.saveSetting)(setting);
            setTips({
                isShow: true,
                type: "success",
                message: "新增成功",
            });
        }
        else if (actionType === "update") {
            tipsRef.current.clear();
            ((setting === null || setting === void 0 ? void 0 : setting.list) || [])[updateIndex || 0] = form;
            setSetting(setting);
            (0, settingHelper_1.saveSetting)(setting);
            setTips({
                isShow: true,
                type: "success",
                message: "修改成功",
            });
        }
    };
    const onSetFormError = (errorMsg) => {
        setTips({
            isShow: true,
            type: "error",
            message: errorMsg,
        });
    };
    const onSetFormInfo = (infoMsg) => {
        setTips({
            isShow: true,
            type: "info",
            message: infoMsg,
        });
    };
    const onSelectSetting = (item) => {
        if (actionType === "delete") {
            // eslint-disable-next-line @typescript-eslint/no-extra-semi
            ;
            ((setting === null || setting === void 0 ? void 0 : setting.list) || []).splice(item.value, 1);
            setSetting(setting);
            (0, settingHelper_1.saveSetting)(setting);
            setSetup(-1);
            setTips({
                isShow: true,
                type: "success",
                message: "删除成功",
            });
        }
        else if (actionType === "update") {
            setUpdateIndex(item.value);
            setSetup(2);
        }
    };
    const onImportConfirm = (value) => {
        setImportText(value);
        setSetup(-1);
        try {
            const settingObj = JSON.parse(value);
            if ((0, utils_1.checkSetting)(settingObj)) {
                setSetting(settingObj);
                setTips({
                    isShow: true,
                    type: "success",
                    message: "导入成功",
                });
                (0, settingHelper_1.saveSetting)(settingObj);
            }
            else {
                setTips({
                    isShow: true,
                    type: "error",
                    message: "导入失败，请检查设置是否正确。",
                });
            }
        }
        catch (error) {
            console.error(error);
            setTips({
                isShow: true,
                type: "error",
                message: "导入失败，请检查设置是否正确。",
            });
        }
    };
    return (react_1.default.createElement(ink_1.Box, { flexDirection: 'column' },
        react_1.default.createElement(Logo_1.default, null),
        setup === 0 && (react_1.default.createElement(Select_1.default, { label: '\u60A8\u8981\u600E\u4E48\u64CD\u4F5C\u901A\u77E5\uFF1F', items: [
                {
                    label: "新增",
                    value: "add",
                },
                {
                    label: "修改",
                    value: "update",
                },
                {
                    label: "删除",
                    value: "delete",
                },
                {
                    label: "查看",
                    value: "query",
                },
                {
                    label: "导入",
                    value: "import",
                },
                {
                    label: "导出",
                    value: "export",
                },
            ], onConfirm: onSelectAction })),
        setup === 1 && (react_1.default.createElement(Select_1.default, { label: `您要${actionType === "update" ? "修改" : "删除"}哪个通知？`, items: (setting.list || []).map((item, index) => {
                return {
                    label: item.title,
                    value: index,
                };
            }), onConfirm: onSelectSetting })),
        setup === 2 && (actionType === "add" || actionType === "update") && (react_1.default.createElement(SetForm_1.default, { initForm: actionType === "update"
                ? ((setting === null || setting === void 0 ? void 0 : setting.list) || [])[updateIndex || 0]
                : undefined, onConfirm: onSetFormConfirm, onError: onSetFormError, onHideError: () => setTips({ isShow: false }), onInfo: onSetFormInfo })),
        setup === 3 &&
            actionType === "query" &&
            ((setting.list || []).length > 0 ? (react_1.default.createElement(MyTable_1.default, { title: '\u901A\u77E5\u914D\u7F6E\u5217\u8868', data: (setting.list || []) })) : null),
        setup === 3 && actionType === "import" && (react_1.default.createElement(ImportSet_1.default, { initValue: importText, onConfirm: onImportConfirm })),
        setup === 3 && actionType === "export" && (react_1.default.createElement(ink_1.Box, { marginTop: 1, borderStyle: "classic", borderColor: theme_1.default.mainColor, padding: 1 },
            react_1.default.createElement(ink_syntax_highlight_1.default, { code: JSON.stringify(setting), language: 'JSON' }))),
        react_1.default.createElement(Tips_1.default, { ref: tipsRef, ...tips })));
};
exports.default = SetView;
