"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const Logo_1 = __importDefault(require("./components/Logo"));
const Tips_1 = __importDefault(require("./components/Tips"));
const settingHelper_1 = require("./common/settingHelper");
// import { ISetForm } from "./components/SetForm";
// eslint-disable-next-line @typescript-eslint/no-var-requires
const notifier = require("node-notifier");
// eslint-disable-next-line @typescript-eslint/no-var-requires
const path = require("path");
// eslint-disable-next-line @typescript-eslint/no-var-requires
const schedule = require("node-schedule");
const setting = (0, settingHelper_1.readSetting)() || {};
const StartView = () => {
    // 提示
    const [tips, setTips] = (0, react_1.useState)({
        isShow: false,
        type: "success",
        message: "",
    });
    (0, react_1.useEffect)(() => {
        doStart();
    }, []);
    const doStart = () => {
        if ((setting.list || []).length === 0) {
            setTips({
                isShow: true,
                type: "info",
                message: "没有发现通知，请先设置通知。",
            });
        }
        else {
            // eslint-disable-next-line @typescript-eslint/no-extra-semi
            ;
            (setting.list || [])
                .filter((set) => set.isTurnOn)
                .map((set) => {
                let scheduleStr = "";
                if (set.cycle === "day") {
                    scheduleStr = `${set.time.split(":").reverse().join(" ")} * * *`;
                }
                else if (set.cycle === "week") {
                    scheduleStr = `${set.time.split(":").reverse().join(" ")} ? * ${set.week}`;
                }
                else if (set.cycle === "custom") {
                    scheduleStr = set.schedule;
                }
                schedule.scheduleJob(scheduleStr, async () => {
                    notifier.notify({
                        title: set.title,
                        message: set.message,
                        icon: path.join(__dirname, "../../assets/icon.jpeg"),
                        sound: true,
                        wait: true,
                    }, (error) => {
                        if (error) {
                            setTips({
                                isShow: true,
                                type: "error",
                                message: "发送通知出错",
                            });
                        }
                        else {
                            setTips({
                                isShow: true,
                                type: "success",
                                message: "发送通知成功",
                            });
                        }
                    });
                });
            });
            setTips({
                isShow: true,
                type: "success",
                message: "启动成功",
            });
        }
    };
    return (react_1.default.createElement(ink_1.Box, { flexDirection: 'column' },
        react_1.default.createElement(Logo_1.default, null),
        react_1.default.createElement(Tips_1.default, { ...tips })));
};
exports.default = StartView;
