"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const Logo_1 = __importDefault(require("./components/Logo"));
const Tips_1 = __importDefault(require("./components/Tips"));
const pm2_1 = __importDefault(require("pm2"));
const shelljs_1 = __importDefault(require("shelljs"));
// eslint-disable-next-line @typescript-eslint/no-var-requires
const wincmd = require('node-windows');
// eslint-disable-next-line @typescript-eslint/no-var-requires
const path = require('path');
// eslint-disable-next-line @typescript-eslint/no-var-requires
const fs = require('fs');
const StopView = () => {
    // 提示
    const [tips, setTips] = (0, react_1.useState)({
        isShow: false,
        type: "success",
        message: "",
    });
    (0, react_1.useEffect)(() => {
        if (process.platform === 'darwin') {
            stopToOSX();
        }
        else if (process.platform === 'win32') {
            stopToWin();
        }
        else {
            setTips({
                isShow: true,
                type: "error",
                message: "暂时不支持该系统。",
            });
        }
        return () => {
            return pm2_1.default.disconnect();
        };
    }, []);
    const stopToOSX = () => {
        pm2_1.default.connect(err => {
            if (err) {
                setTips({
                    isShow: true,
                    type: "error",
                    message: "连接pm2失败",
                });
                setTimeout(() => {
                    process.exit(1);
                }, 0);
            }
            pm2_1.default.stop("coder-notifier", err => {
                if (err) {
                    setTips({
                        isShow: true,
                        type: "error",
                        message: "停止coder-notifier进程失败，请检查是否启动过coder-notifier",
                    });
                    setTimeout(() => {
                        process.exit(1);
                    }, 0);
                }
                else {
                    setTips({
                        isShow: true,
                        type: "success",
                        message: "停止coder-notifier进程成功",
                    });
                    pm2_1.default.delete("coder-notifier", err => {
                        if (err) {
                            setTips({
                                isShow: true,
                                type: "error",
                                message: "删除coder-notifier进程失败",
                            });
                            setTimeout(() => {
                                process.exit(1);
                            }, 0);
                        }
                        else {
                            setTips({
                                isShow: true,
                                type: "success",
                                message: "删除coder-notifier进程成功",
                            });
                            shelljs_1.default.exec("pm2 save --force", {
                                silent: true,
                            });
                            setTips({
                                isShow: true,
                                type: "success",
                                message: "完成",
                            });
                            setTimeout(() => {
                                process.exit(0);
                            }, 0);
                        }
                    });
                }
            });
        });
    };
    const stopToWin = () => {
        wincmd.isAdminUser((isAdmin) => {
            if (isAdmin) {
                const batLinkPath = path.join("C:\\ProgramData\\Microsoft\\Windows\\Start Menu\\Programs\\Startup\\win-save-link.bat");
                if (fs.existsSync(batLinkPath)) {
                    fs.rmSync(batLinkPath);
                    setTips({
                        isShow: true,
                        type: "success",
                        message: "删除开机启动项成功",
                    });
                }
                shelljs_1.default.exec('taskkill /im node.exe /f', {
                    silent: true,
                });
                setTips({
                    isShow: true,
                    type: "success",
                    message: "退出成功",
                });
                setTimeout(() => {
                    process.exit(0);
                }, 10);
            }
            else {
                setTips({
                    isShow: true,
                    type: "error",
                    message: "请使用管理员身份运行",
                });
                setTimeout(() => {
                    process.exit(1);
                }, 10);
            }
        });
    };
    return (react_1.default.createElement(ink_1.Box, { flexDirection: 'column' },
        react_1.default.createElement(Logo_1.default, null),
        react_1.default.createElement(Tips_1.default, { ...tips })));
};
exports.default = StopView;
