"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkSetting = void 0;
const settingKeys = ["list"];
const settingListType = {
    title: (item, key) => typeof item[key] === "string",
    message: (item, key) => typeof item[key] === "string",
    cycle: (item, key) => ["day", "week", "custom"].includes(item[key]),
    week: (item, key) => [1, 2, 3, 4, 5, 6, 7].includes(item[key]),
    time: (item, key) => {
        if (item['cycle'] !== 'custom') {
            return /([0-1]\d|2[0-4]):[0-5]\d:[0-5]\d/.test(item[key]);
        }
        else {
            return true;
        }
    },
    isTurnOn: (item, key) => typeof item[key] === "boolean",
    remark: (item, key) => typeof item[key] === "string",
    schedule: (item, key) => {
        if (item['cycle'] === 'custom') {
            return new RegExp(`(((^([0-9]|[0-5][0-9])(\\,|\\-|\\/){1}([0-9]|[0-5][0-9]) )|^([0-9]|[0-5][0-9]) |^(\\* ))((([0-9]|[0-5][0-9])(\\,|\\-|\\/){1}([0-9]|[0-5][0-9]) )|([0-9]|[0-5][0-9]) |(\\* ))((([0-9]|[01][0-9]|2[0-3])(\\,|\\-|\\/){1}([0-9]|[01][0-9]|2[0-3]) )|([0-9]|[01][0-9]|2[0-3]) |(\\* ))((([0-9]|[0-2][0-9]|3[01])(\\,|\\-|\\/){1}([0-9]|[0-2][0-9]|3[01]) )|(([0-9]|[0-2][0-9]|3[01]) )|(\\? )|(\\* )|(([1-9]|[0-2][0-9]|3[01]) )|([1-7] )|( )|([1-7]\\#[1-4] ))((([1-9]|0[1-9]|1[0-2])(\\,|\\-|\\/){1}([1-9]|0[1-9]|1[0-2]) )|([1-9]|0[1-9]|1[0-2]) |(\\* ))(([1-7](\\,|\\-|\\/){1}[1-7])|([1-7])|(\\?)|(\\*)|(([1-7])|([1-7]\\#[1-4]))))|(((^([0-9]|[0-5][0-9])(\\,|\\-|\\/){1}([0-9]|[0-5][0-9]) )|^([0-9]|[0-5][0-9]) |^(\\* ))((([0-9]|[0-5][0-9])(\\,|\\-|\\/){1}([0-9]|[0-5][0-9]) )|([0-9]|[0-5][0-9]) |(\\* ))((([0-9]|[01][0-9]|2[0-3])(\\,|\\-|\\/){1}([0-9]|[01][0-9]|2[0-3]) )|([0-9]|[01][0-9]|2[0-3]) |(\\* ))((([0-9]|[0-2][0-9]|3[01])(\\,|\\-|\\/){1}([0-9]|[0-2][0-9]|3[01]) )|(([0-9]|[0-2][0-9]|3[01]) )|(\\? )|(\\* )|(([1-9]|[0-2][0-9]|3[01]) )|([1-7] )|( )|([1-7]\\#[1-4] ))((([1-9]|0[1-9]|1[0-2])(\\,|\\-|\\/){1}([1-9]|0[1-9]|1[0-2]) )|([1-9]|0[1-9]|1[0-2]) |(\\* ))(([1-7](\\,|\\-|\\/){1}[1-7] )|([1-7] )|(\\? )|(\\* )|(([1-7] )|([1-7]\\#[1-4]) ))((19[789][0-9]|20[0-9][0-9])\\-(19[789][0-9]|20[0-9][0-9])))`).test(item[key]);
        }
        else {
            return true;
        }
    }
};
const checkSetting = (obj) => {
    let result = true;
    const keys = Object.keys(obj);
    settingKeys.map(key => {
        if (!keys.includes(key)) {
            result = false;
        }
        else {
            if (key === "list") {
                // eslint-disable-next-line @typescript-eslint/no-extra-semi
                ;
                (obj[key] || []).map((item) => {
                    const settingListKey = Object.keys(settingListType);
                    settingListKey.map(listKey => {
                        if (!settingListType[listKey](item, listKey)) {
                            result = false;
                        }
                    });
                });
            }
        }
    });
    return result;
};
exports.checkSetting = checkSetting;
