"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const ink_1 = require("ink");
const theme_1 = __importDefault(require("../common/theme"));
const ink_select_input_1 = __importDefault(require("ink-select-input"));
const SelectIndicator_1 = __importDefault(require("./SelectIndicator"));
const SelectItem_1 = __importDefault(require("./SelectItem"));
const Select = ({ label, placeholder, items, initialIndex = 0, onConfirm }) => {
    return (react_1.default.createElement(ink_1.Box, { flexDirection: 'column' },
        react_1.default.createElement(ink_1.Box, { marginBottom: 1 },
            react_1.default.createElement(ink_1.Text, { color: theme_1.default.mainColor },
                label,
                react_1.default.createElement(ink_1.Text, { color: 'gray' }, placeholder))),
        react_1.default.createElement(ink_select_input_1.default, { items: items, initialIndex: initialIndex, onSelect: onConfirm, indicatorComponent: SelectIndicator_1.default, itemComponent: SelectItem_1.default })));
};
exports.default = Select;
